// ==UserScript==
// @name          Pure Basic Syntax Highlighting
// @namespace Violentmonkey Scripts
// @grant none
// @description   Pure Basic Syntax Highlighting (V 1.6) (16. Feb 2011)
// @include       https://purebasic.com/german/*
// @include       https://purebasic.fr/german/*
// @include       https://purebasic.fr/english/*
// @include       https://purebasic.fr/french/*
// @include       https://www.purebasic.com/german/*
// @include       https://www.purebasic.fr/german/*
// @include       https://www.purebasic.fr/english/*
// @include       https://www.purebasic.fr/french/*
// @include       https://forums.purebasic.com/german/*
// @include       https://forums.purebasic.com/english/*
// @include       https://forums.purebasic.fr/german/*
// @include       https://forums.purebasic.fr/english/*
// @include       https://forums.purebasic.fr/french/*
// @include       https://forums.spiderbasic.com/*

// ==/UserScript==





//--------------------------------------------
// Version 1.6 (16. Feb 2011)
//--------------------------------------------





// Farbdefinition f&uuml;r das Syntax Highlighting
// color definition for the syntax highlighting
//===================================================

 var PBSH_Highlight = new Object();

 // ==PureBasicPreference==

  PBSH_Highlight['EnableKeywordBolding'] = 1;
  PBSH_Highlight['EditorFontName'] = 'inconsolata';
  PBSH_Highlight['EditorFontSize'] = '12';
  PBSH_Highlight['EditorFontStyle'] = '';
  PBSH_Highlight['BackgroundColor'] = '#D9EAFF';
  PBSH_Highlight['NormalTextColor'] = '#000000';
  PBSH_Highlight['BasicKeywordColor'] = '#000080';
  PBSH_Highlight['CommentColor'] = '#006400';
  PBSH_Highlight['ConstantColor'] = '#800000';
  PBSH_Highlight['StringColor'] = '#646464';
  PBSH_Highlight['PureKeywordColor'] = '#0000FF';
  PBSH_Highlight['ASMKeywordColor'] = '#924B72';
  PBSH_Highlight['PointerColor'] = '#000000';
  PBSH_Highlight['NumberColor'] = '#FF0000';
  PBSH_Highlight['StructureColor'] = '#000000';
  PBSH_Highlight['LabelColor'] = '#000000';
  PBSH_Highlight['OperatorColor'] = '#FF0000';
  PBSH_Highlight['SeparatorColor'] = '#000000';


 // ==/PureBasicPreference==

//===================================================







// UserScript f&uuml;r die Syntaxhervorhebung
// user script for syntax highlighting
//===================================================

 // Regul&auml;rer Ausdr&uuml;ck f&uuml;r das SyntaxHighlighting
 // regular expressions for the syntax lighting
 //                |( Keyword                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             )|( Comment           )|( Constant           )|( String    )|( Function                                                 )|( ASM                           )|( Pointer                                     )|( Number                                       )|( Structure                                                                                                                   )|( Label                     )|( Operator                   )|( Separator   )|
var PBSH_Syntax = /([^\w";\\][ \t]*(?:Align|And|Array|As|Break|CallDebugger|Case|CompilerCase|CompilerDefault|CompilerElse|CompilerElseIf|CompilerEndIf|CompilerEndSelect|CompilerError|CompilerIf|CompilerEndIf|CompilerSelect|CompilerEndSelect|Continue|Data|DataSection|EndDataSection|Debug|DebugLevel|Declare|DeclareC|DeclareCDLL|DeclareDLL|DeclareModule|Default|Define|Dim|DisableASM|DisableDebugger|DisableExplicit|Else|ElseIf|EnableASM|EnableDebugger|EnableExplicit|End|EndDataSection|EndDeclareModule|EndEnumeration|EndIf|EndImport|EndInterface|EndMacro|EndModule|EndProcedure|EndSelect|EndStructure|EndStructureUnion|EndWith|Enumeration|EnumerationBinary|EndEnumeration|Extends|FakeReturn|For|Next|ForEach|Next|ForEver|Global|Gosub|Goto|If|EndIf|Import|EndImport|ImportC|EndImport|IncludeBinary|IncludeFile|IncludePath|Interface|EndInterface|List|Macro|EndMacro|MacroExpandedCount|Module|Map|NewList|NewMap|Next|Not|Or|Procedure|EndProcedure|ProcedureC|EndProcedure|ProcedureCDLL|EndProcedure|ProcedureDLL|EndProcedure|ProcedureReturn|Protected|Prototype|PrototypeC|Read|ReDim|Repeat|Until|Restore|Return|Runtime|Select|EndSelect|Shared|Static|Step|Structure|EndStructure|StructureUnion|EndStructureUnion|Swap|Threaded|To|UndefineMacro|Until|UseModule|UnuseModule|Wend|While|Wend|With|EndWith|XIncludeFile|XOr)(?!\w))|(;[^\r\n]*(?=[\r\n]))|(\#\w*\$?|'[^'\r\n]*')|("[^"\r\n]*")|([^\w.][ \t]*\w+\$?(?=(?:[ \t]*\.[ \t]*\w+[ \t]*|[ \t]*)\())|([\n][ \t]*![^\r\n;]*(?=[\n\r;]))|(.\@\*?[\w\$]*|[^\w$)\]][ \t]*\*[\w\$]+|.\?\w*)|(\W(?:\d+\.?[e\d]*|\$[\dabcdef]+|\%[01]+)(?!\w))|(\.[ \t]*(?:[^\Wabcdfilqsuw](?!\w)|\w\w+)|\\[ \t]*\w+\$?|\W\w+(?=[ \t]*\\)|\W\w+(?=[ \t]*\.[ \t]*(?:[^\Wabcdfilqsuw]\W|\w\w+)))|([\n][ \t]*\w+\$?(?=[ \t]*:))|([+*/\-|!%=~]|&amp;|&lt;|&gt;)|([()\[\]\\:,.])/gi ;

 // Hervorheben einer Zeichenkette
 // highlighting a string
 function PBSH_Highlighting(str, key)
  {
  if (PBSH_Highlight[key])
   return '<font color="'+PBSH_Highlight[key]+'">'+str+'</font>';
  else
   return str;
  }
 function PBSH_Highlighting_Shift(str, key)
  {
  if (PBSH_Highlight[key])
   {
   var chr = str.slice(0,1);
   if (PBSH_Highlight['OperatorColor'])
    chr = chr.replace(PBSH_Syntax, PBSH_Replace);
   else if (PBSH_Highlight['SeparatorColor'])
    chr = chr.replace(PBSH_Syntax, PBSH_Replace);
   return chr+'<font color="'+PBSH_Highlight[key]+'">'+str.slice(1,str.length)+'</font>';
   }
  else
   return str;
  }
 function PBSH_Highlighting_Keyword(str, key)
  {
  if (PBSH_Highlight[key])
   {
   var space = str.lastIndexOf(' ');
   if (space==-1) space = 0;
   var chr = str.slice(0,space+1);
   if (PBSH_Highlight['SeparatorColor'])
    chr = chr.replace(PBSH_Syntax, PBSH_Replace);
   if (PBSH_Highlight['EnableKeywordBolding'])
    return chr+'<font color="'+PBSH_Highlight[key]+'"><b>'+str.slice(space+1,str.length)+'</b></font>';
   else
    return chr+'<font color="'+PBSH_Highlight[key]+'">'+str.slice(space+1,str.length)+'</font>';
   }
  else
   if (PBSH_Highlight['EnableKeywordBolding'])
    return '<b>'+str+'</b>';
   else
    return str;
  }

 // Ersetzen einer Zeichenkette
 // replace a string
 function PBSH_Replace(str, isKeyword, isComment, isConstant, isString, isFunction, isASM, isPointer, isNumber, isStructure, isLabel, isOperator, isSeparator)
  {
  if (isKeyword)        return PBSH_Highlighting_Keyword(isKeyword, 'BasicKeywordColor');
  else if (isComment)   return PBSH_Highlighting(isComment, 'CommentColor');
  else if (isConstant)  return PBSH_Highlighting(isConstant, 'ConstantColor');
  else if (isString)    return PBSH_Highlighting(isString, 'StringColor');
  else if (isFunction)  return PBSH_Highlighting_Shift(isFunction, 'PureKeywordColor');
  else if (isASM)       return PBSH_Highlighting_Shift(isASM, 'ASMKeywordColor');
  else if (isPointer)   return PBSH_Highlighting_Shift(isPointer, 'PointerColor');
  else if (isNumber)    return PBSH_Highlighting_Shift(isNumber, 'NumberColor');
  else if (isStructure) return PBSH_Highlighting_Shift(isStructure, 'StructureColor');
  else if (isLabel)     return PBSH_Highlighting_Shift(isLabel, 'LabelColor');
  else if (isOperator)  return PBSH_Highlighting(isOperator, 'OperatorColor');
  else if (isSeparator) return PBSH_Highlighting(isSeparator, 'SeparatorColor');
  }

 // Durchf&uuml;hres der Syntaxhervorhebung
 // carry out the syntax highlighting
 function PureBasicSyntaxHighlighting()
  {
  // Anwenden der Syntaxhervorhebung auf alle Elemente mit der Klasse codecontent
  // apply the syntax highlighting on all the elements with class codecontent
  var allMyDivs = document.getElementsByTagName('div');
  for(var i = 0; i < allMyDivs.length; i++)
   {
   if (allMyDivs[i].className == 'codecontent')
    {
    if (PBSH_Highlight['EditorFontName'])
     allMyDivs[i].style.font = PBSH_Highlight['EditorFontStyle']+" "+PBSH_Highlight['EditorFontSize']+"pt "+PBSH_Highlight['EditorFontName'];
    if (PBSH_Highlight['BackgroundColor'])
     allMyDivs[i].style.backgroundColor = PBSH_Highlight['BackgroundColor'];
    if (PBSH_Highlight['NormalTextColor'])
     allMyDivs[i].style.color           = PBSH_Highlight['NormalTextColor'];
    var code = ' '+allMyDivs[i].innerHTML+'\r';
    code = code.replace(/<br>/gi, '\r\n');
    code = code.replace(/&nbsp;/gi, '\t');
    code = code.replace(/<\/?[^<>]*>/gi, '');
    code = code.replace(PBSH_Syntax, PBSH_Replace);
    code = code.replace(/\t/gi, '&nbsp;');
    code = code.replace(/\r\n/gi, '<br>');
    allMyDivs[i].innerHTML = code;
    }
   }
  }

 PureBasicSyntaxHighlighting();

//===================================================
